diff -Nur source.orig\SftpControlSocket.cpp source.patch\SftpControlSocket.cpp
--- source.orig\SftpControlSocket.cpp	Sun Aug 22 21:58:24 2004
+++ source.patch\SftpControlSocket.cpp	Sat Mar 12 22:30:59 2005
@@ -326,7 +326,7 @@
 		if (m_Operation.nOpState==LIST_PWD)
 		{ //Reply to PWD command
 			pData->realpath.SetServer(m_CurrentServer);
-			if (m_Reply=="" || !pData->realpath.SetPath(m_Reply))
+			if (m_Reply=="" || !pData->realpath.SetPath(A2CT(m_Reply)))
 			{
 				LogMessage(__FILE__, __LINE__, this,FZ_LOG_WARNING, _T("Can't parse path") );
 				ResetOperation(FZ_REPLY_ERROR);
@@ -363,7 +363,7 @@
 		else if (m_Operation.nOpState==LIST_CWD)
 		{
 			pData->realpath.SetServer(m_CurrentServer);
-			if (m_Reply=="" || !pData->realpath.SetPath(m_Reply))
+			if (m_Reply=="" || !pData->realpath.SetPath(A2CT(m_Reply)))
 			{
 				LogMessage(__FILE__, __LINE__, this,FZ_LOG_WARNING, _T("Can't parse path") );
 				ResetOperation(FZ_REPLY_ERROR);
@@ -410,7 +410,7 @@
 		else if (m_Operation.nOpState==LIST_CWD2)
 		{
 			pData->realpath.SetServer(m_CurrentServer);
-			if (m_Reply=="" || !pData->realpath.SetPath(m_Reply))
+			if (m_Reply=="" || !pData->realpath.SetPath(A2CT(m_Reply)))
 			{
 				LogMessage(__FILE__, __LINE__, this,FZ_LOG_WARNING, _T("Can't parse path") );
 				ResetOperation(FZ_REPLY_ERROR);
@@ -455,7 +455,7 @@
 			if (m_Reply!="")
 			{
 				char *data = new char[m_Reply.GetLength()+2+1];
-				strcpy(data, T2CA(m_Reply+"\r\n"));
+				strcpy(data, m_Reply+"\r\n");
 				pData->pParser->AddData(data, m_Reply.GetLength()+2);
 			}
 			else
@@ -821,7 +821,7 @@
 			{
 				CServerPath path;
 				path.SetServer(m_CurrentServer);
-				if (!path.SetPath(m_Reply))
+				if (!path.SetPath(A2CT(m_Reply)))
 				{
 					LogMessage(__FILE__, __LINE__, this,FZ_LOG_WARNING, _T("Can't parse path"));
 					nReplyError=FZ_REPLY_ERROR;
@@ -1046,7 +1046,7 @@
 			{
 				CServerPath path;
 				path.SetServer(m_CurrentServer);
-				if (!path.SetPath(m_Reply))
+				if (!path.SetPath(A2CT(m_Reply)))
 				{
 					LogMessage(__FILE__, __LINE__, this,FZ_LOG_WARNING, _T("Can't parse path"));
 					nReplyError=FZ_REPLY_ERROR;
@@ -1137,7 +1137,7 @@
 				if (m_Reply != "")
 				{
 					char *data=new char[m_Reply.GetLength()+2+1];
-					strcpy(data, T2CA(m_Reply+"\r\n"));
+					strcpy(data, m_Reply+"\r\n");
 					pData->pParser->AddData(data, m_Reply.GetLength()+2);
 					return;
 				}
@@ -1336,8 +1336,8 @@
 			filename = pData->transferfile.remotefile;
 		else
 			filename = pData->transferfile.remotepath.GetPath() + pData->transferfile.remotefile;
-		int nLen1=filename.GetLength() + 1;
-		int nLen2=pData->transferfile.localfile.GetLength()+1;
+		int nLen1=strlen(T2CA(filename)) + 1;
+		int nLen2=strlen(T2CA(pData->transferfile.localfile))+1;
 		char *pCmd=new char[nLen1+nLen2+4];
 		strcpy(pCmd, T2CA(filename));
 		strcpy(pCmd+nLen1, T2CA(pData->transferfile.localfile));
@@ -2330,7 +2330,7 @@
 
 			str.Format(IDS_STATUSMSG_CONNECTEDWITHSFTP, m_ServerName);
 			ShowStatus(str,0);
-			char *data=new char[m_CurrentServer.host.GetLength() + m_CurrentServer.user.GetLength() + m_CurrentServer.pass.GetLength() + 4 + 3 + 2];
+			char *data=new char[strlen(T2CA(m_CurrentServer.host + m_CurrentServer.user + m_CurrentServer.pass)) + 4 + 3 + 2];
 			char *p=data;
 			strcpy(p, T2CA(m_CurrentServer.host));
 			p+=strlen(p)+1;
@@ -2922,7 +2922,7 @@
 	m_Operation.nOpMode=CSMODE_CHMOD;
 	CString str;
 	str.Format( _T("%d %s%s"), nValue, path.GetPath(), filename);
-	int nLen=str.GetLength()+1;
+	int nLen=strlen(T2CA(str))+1;
 	char *pData=new char[nLen];
 	strcpy(pData, T2CA(str));
 	int pos(str.Find( _T(" ") ));
diff -Nur source.orig\SftpControlSocket.h source.patch\SftpControlSocket.h
--- source.orig\SftpControlSocket.h	Mon Jun 07 22:59:16 2004
+++ source.patch\SftpControlSocket.h	Sat Mar 12 22:26:14 2005
@@ -75,7 +75,7 @@
 	int CheckOverwriteFile();
 
 	BOOL m_bQuit;
-	CString m_Reply;
+	CStringA m_Reply;
 	BOOL m_bCheckForTimeout;
 	virtual void DoClose(int nError = 0);
 	void ResetOperation(int nSuccessful = -1);
